<?php
/**
 * @file zen.php
 * @author Juan Belon
 * @access public
 * @copyright LGPL, GPL
 * @package zenphp
 * @version 1.0
 * @uses zenphp FrameWork
 * 
 * @brief Genera el sistema y define todas las constantes
 */
// +----------------------------------------------------------------------
// | zenphp.es
// +----------------------------------------------------------------------


/* _________________ PARAMETROS DEL SISTEMA _________________ */
session_start();
/*
|---------------------------------------------------------------
| NIVEL DE REPORTE DE ERRORES && MODO DEPURACION
|---------------------------------------------------------------
*
| Una vez que el sitio sea online se puede pasar de E_ALL a E_WARNING|E_ERROR y ZF_MODO_DEPURACION a false
| El modo guardar log es para almacenar los errores ocurridos en tiempo de ejecución en el directorio ZF_DIR_ERROR_LOG
*/
//---------------------------------------------------------------
define('ZF_MODO_DEPURACION',false);
define('ZF_MODO_GUARDAR_LOG',true);
//---------------------------------------------------------------
if (ZF_MODO_DEPURACION) error_reporting(E_ALL);
else error_reporting(E_WARNING|E_ERROR);
/*
|---------------------------------------------------------------
| DIRECTORIO PARA EL FRAMEWORK ZEN PHP Y LAS PLANTILLAS :
|---------------------------------------------------------------
*
| Nota: Nombre de sistema y plantillas sin /
*
*/
define('ZF_CARPETA_ZEN',"zenphp");
define('ZF_CARPETA_PLANTILLAS',"media/plantillas");
/*
|---------------------------------------------------------------
| NOMBRE DEL DIRECTORIO PARA LAS APLICACIONES
|---------------------------------------------------------------
*
| Directorio donde residen las aplicaciones dentro del sistema zen php sin /
*
*/
$directorio_aplicaciones = "aplicaciones";

/* _______________ PARAMETROS DEL SISTEMA [FIN] ________________ */

/*
|---------------------------------------------------------------
| CONFIGURANDO LA RUTA DESDE DEL SERVIDOR AL SISTEMA
|---------------------------------------------------------------
*
*/
if (function_exists('realpath') AND @realpath(dirname(__FILE__)) !== FALSE)
{
	$carpeta_zen = str_replace("\\", DIRECTORY_SEPARATOR, realpath(dirname(__FILE__))).DIRECTORY_SEPARATOR.ZF_CARPETA_ZEN;
}

/**
 * Historia zen para amenizar el trabajo:
 * Digen dijo a su maestro Nyojo: "Abandoné mi cuerpo y mi espíritu." 
 * Esto significa que a través de zazen, 
 * uno puede emanciparse de la conciencia del pasado y que se vuelve,
 * en cuerpo y en espíritu a la auténtica conciencia de antes de la existencia humana. 
 * La conciencia del pasado ya no es un problema, su cuerpo y su espíritu anteriores se resuelven en zazen. 
 * Ud.crea su verdadera vida, en donde la sabiduría se engendra naturalmente.:)"
|---------------------------------------------------------------
| CONSTANTES PARA LAS APLICACIONES :: TODAS EMPIEZAN POR ZF (de ZenFrameWork)
|---------------------------------------------------------------
*
| ZF_PREFIJO_CLASE    - Nombre dado a las clases en singular : clase
| ZF_PREFIJO_CLASES   - Nombre dado a las clases en plural   : clases
| ZF_SITIO_WEB	      - Sitio web donde se encuentra la aplicacion principal: http://localhost/
| ZF_DIR_PPAL	      - Directorio principal de la pagina web
| ZF_DIR_PPAL_ZEN     - Directorio principal del sistema zen php
| ZF_DIR_CONFIG		  - Directorio de los ficheros de configuracion
| ZF_DIR_CLASES       - Directorio principal de los ficheros de clases del __SISTEMA__! (todos los ficheros de clases han de llamarse clase_zen_NOMBRECLASE.php)
| ZF_DIR_LIBRERIAS    - Directorio principal de los ficheros de clases (todos los ficheros de clases han de llamarse clase_NOMBRECLASE.php), son externos al sistema pero se usan dentro de el...
| ZF_DIR_JSCRIPT      - Directorio de los ficheros javascript
| ZF_DIR_FUNCIONES    - Directorio de los ficheros de funciones del sistema zen php
| ZF_DIR_APLICACIONES - Directorio de los ficheros de aplicaciones del usuario que use el SDK
| ZF_DIR_PLANTILLAS   - Directorio de los ficheros de plantillas del usuario que lo use ;-)
| ZF_DIR_CONTENIDO_ZEN- Directorio de los ficheros de plantillas de zenphp
| ZF_DIR_FUENTES      - Directorio para guardar las fuentes true type con las que operan en las imagenes y otros elementos...
| ZF_CORREO_ADMIN     - Correo desde el que se envian los mails en el sistema
| ZF_PALABRA_SECRETA  - Constante para generar partes privadas como sesiones seguras y otras...
| ZF_IDIOMA_DEFECTO   - Idioma por defecto
| ZF_IDIOMAS          - Idiomas de la web
| ZF_IDIOMA_COOKIE    - Constante para utilizar como nombre de variable de cookie de sesion para guardar el idioma utilizado en la web
| ZF_VERSION          - Version de Zen PHP Framework :: llevando la meditacion al codigo ;-)
| ZF_SEGURO_ZEN       - Constante para asegurarnos que el sistema ha sido cargado desde el principio correctamente
| ZF_DIR_ERROR_LOG    - Directorio para guardar el log de los errores ocurridos en tiempo de ejecución de zenphp
*/
define('ZF_PREFIJO_CLASE', 'clase');
define('ZF_PREFIJO_CLASES','clases');
define('ZF_SITIO_WEB','http://localhost/aplicacion');
define('ZF_DIR_PPAL', pathinfo(__FILE__, PATHINFO_DIRNAME).DIRECTORY_SEPARATOR);
define('ZF_DIR_PPAL_ZEN', $carpeta_zen.DIRECTORY_SEPARATOR);
define('ZF_DIR_CONFIG',ZF_DIR_PPAL_ZEN.'config'.DIRECTORY_SEPARATOR);
define('ZF_DIR_CLASES',ZF_DIR_PPAL_ZEN.ZF_PREFIJO_CLASES.DIRECTORY_SEPARATOR);
define('ZF_DIR_LIBRERIAS',ZF_DIR_PPAL_ZEN.'librerias'.DIRECTORY_SEPARATOR);
define('ZF_DIR_JSCRIPT',ZF_DIR_PPAL_ZEN.'js'.DIRECTORY_SEPARATOR);
define('ZF_DIR_FUNCIONES',ZF_DIR_PPAL_ZEN.'funciones'.DIRECTORY_SEPARATOR);
define('ZF_DIR_APLICACIONES',ZF_DIR_PPAL.$directorio_aplicaciones.DIRECTORY_SEPARATOR);
define('ZF_DIR_PLANTILLAS',ZF_DIR_PPAL.ZF_CARPETA_PLANTILLAS.DIRECTORY_SEPARATOR);
define('ZF_DIR_CONTENIDO_ZEN',ZF_DIR_PPAL_ZEN.DIRECTORY_SEPARATOR.'contenido'.DIRECTORY_SEPARATOR);
define('ZF_DIR_FUENTES',ZF_DIR_PPAL_ZEN.'fuentes'.DIRECTORY_SEPARATOR);
define('ZF_CORREO_ADMIN','correo@administrador.com');
define('ZF_PALABRA_SECRETA','ABANDONAR_');
define('ZF_IDIOMA_DEFECTO','es');
define('ZF_IDIOMAS','es,en,de');
define('ZF_IDIOMA_COOKIE','len');
define('ZF_VERSION',	'1.0.0');
define('ZF_SEGURO_ZEN',true);
define('ZF_DIR_ERROR_LOG',ZF_DIR_PPAL_ZEN.'error_log'.DIRECTORY_SEPARATOR);
/*
 Al ejecutarse la clase principal aparecen nuevas constantes que no están en éste fichero sino que 
 son definidas dinámicamente desde el constructor de la clase principal del SDK: zen() en clases/clase_zen.php
 | ZF_DIR_IDIOMA      - Directorio del idioma para la configuracion de ejecucion actual
 | ZF_DIR_PLAN_IDI    - Directorio de las plantillas para la configuracion de ejecucion actual
 | por eso hace falta definir este nombre del directorio de plantillas para el idioma en ejecucion actual:
*/
/**
 | ZF_NOM_DIR_PLAN_IDI- Constante: nombre del directorio de plantillas para el idioma en ejecucion actual (sin /)
 */
define('ZF_NOMBRE_DIR_PL_IDI','plantillas');
//Ahora hacemos comprobaciones de existencia del directorio de aplicaciones:
if (!is_dir(ZF_DIR_APLICACIONES)) die(printf('El directorio de aplicaciones %s no existe.',ZF_DIR_APLICACIONES));
/*
|---------------------------------------------------------------
| PARA VERSIONES DE PHP ANTIGUAS :: DEFINIR E_STRICT
|---------------------------------------------------------------
*
| Definir la constante para que no de error.
*
*/
if ( ! defined('E_STRICT'))
{
	define('E_STRICT', 2048);
}
// Sin magic quotes mejor :D usamos addslashes() y otras funciones...
set_magic_quotes_runtime(0); 

//Cargar las funciones del núcleo de zenphp,para poder realizar operaciones más "interesantes":
require_once(ZF_DIR_FUNCIONES.'zen_nucleo.php');
//Cargar las funciones generales,entre ellas la de sanar (para ejecutar comandos shell...quitar HTML, comillas)...por lo que quitamos "magic quotes"
zen___cargar_funciones('zen_general');
//Por defecto cargaremos las funciones HTML y de fechas para representar la información
zen___cargar_funciones('zen_html');
//Fechas:
zen___cargar_funciones('zen_fechas');
/*
 * ------------------------------------------------------
 * Además, ahora podemos definir el manejador de errores:
 * ------------------------------------------------------
 */
set_error_handler('zen__manejador_de_errores');
//Preparar el sistema
require_once(ZF_DIR_CLASES.'clase_zen.php');
/**
 * NOTAS:
 * - El resto de configuracion se encuentra en zenphp/configuracion
 * - La carpeta de plantillas debe de estar al mismo nivel que /zenphp/ y ha de contener plantillas generales asi como para cada idioma:
 *   -> es  //carpeta para guardar constantes del idioma español
 *      ->  plantillas // para guardar ficheros .html de las plantillas españolas
 *   -> en  //directorio para guarda ctes. en ingles
 *      ->   plantillas //plantillas en ingles
 * ...etc...
 *   -> general // donde se buscaran las plantillas en el caso de que no se encuentren en los idiomas
 * - Recordar no ponerle el mismo nombre a una plantilla o directorio de plantillas dentro de idiomas y general...se coge primero la general ;-)
**/
?>