<?php
/**
 * @file clase_zen_modelo_datos.php
 * @author Juan Belon
 * @access public
 * @copyright LGPL, GPL
 * @package zenphp
 * @version 1.0
 * @uses zenphp FrameWork
 * 
 * @brief Clase que genera un modelo de datos a partir de una lista de campos y de tablas
//TODO:por venir : scaffolding
 */
// +----------------------------------------------------------------------
// | zenphp.es
// +----------------------------------------------------------------------
if (!defined('ZF_SEGURO_ZEN')) exit('Acceso directo no permitido');
class zen_modelo_datos {
	/**
	 * Aplicacion web
	 *
	 * @var zen
	 */
	var $padre;
	/**
	 * Listado de campos de las tablas separados por comas, poner el identificador principal el primero
	 *
	 * @var str
	 */
	var $campos;
	/**
	 * Nombre de las tablas asociadas al modelo de datos
	 *
	 * @var str
	 */
	var $tablas;
	/**
	 * Condiciones para filtrar los datos en los listados
	 *
	 * @var str
	 */
	var $condiciones_where;
	/**
	 * Clase de BD MySQL
	 *
	 * @var zen_basedatos
	 */
	var $bd;
	/**
	 * Clase para manejar productos de categorias si la hubiera
	 *
	 * @var zen_modelo_datos
	 */
	var $subcategoria = null;
	/**
	 * clase html que usa el modelo
	 *
	 * @var zen_html_modelo_datos
	 */
	var $html;
	/**
	 * Controlador del modelo de datos
	 *
	 * @var zen_controlador_modelo_datos
	 */
	var $controlador;
	/**
	 * Modelo de datos para mostrar en la web
	 *
	 * @param zen $_padre
	 * @param str $campos
	 * @param str $tablas
	 * @param str $subcategoria
	 * @param str $condiciones_where
	 * @return zen_modelo_datos
	 */
	function zen_modelo_datos(&$_padre,$campos="",$tablas="",$subcategoria=null,$condiciones_where=""){
		$this->padre  =& $_padre;
		$this->bd     =  $this->padre->bd;
		$this->campos =  $campos;
		$this->tablas =  $tablas;
		$this->condiciones_where = $condiciones_where;
		zen___carga_clase(  'zen_html_modelo_datos'     );
		$this->html   =& new zen_html_modelo_datos($this);
		zen___carga_clase('zen_controlador_modelo_datos');
		$this->controlador=& new zen_controlador_modelo_datos($this);
		if ($subcategoria!=''){
		 if (zen___carga_clase($subcategoria))
		  eval('$this->subcategoria =& new '.$subcategoria.'($this)');
		}
	}
	 /**
	  * Devuelve una lista de categorias con las opciones pasadas...son todas opcionales
	  *
	  * @param str $where
	  * @param str $tablas
	  * @param str $from
	  * @param str $order
	  * @param str $limit
	  * @return array
	  */
	function obtener($campos="",$tablas="",$where="",$order="",$limit="",$num_campos=0){
		if (empty($campos)) $campos = $this->campos;		
		if (empty($tablas)) $tablas = $this->tablas;
		if (empty($where))  $where  = $this->condiciones_where;
		$r = $this->bd->seleccion($campos." from ".$tablas." ".$where." ".$order." ".$limit);
		if (!$r) return false;
		$tuplas = array();
		while ($tupla = $this->bd->obtener_fila($r)) {
			array_push($tuplas,$tupla);
		}
		@mysql_free_result($r);
		return $tuplas;
	}
	/**
	 * Obtiene el primer dato del modelo de datos
	 *
	 * @param str $campos
	 * @param str $tablas
	 * @param str $where
	 * @param str $orden
	 * @return array
	 */
	function obtener_primero($campos="",$tablas="",$where="",$orden=""){
		$dato = $this->obtener($campos,$tablas,$where,$orden," LIMIT 1");
		return $dato[0];
	}
	/**
	 * Si necesitamos usar otra BD distinta o no crear la clase zen_modelo_datos podemos usar esta funcion
	 *
	 * @param zen_basedatos $bd
	 * @param str $campos
	 * @param str $tablas
	 * @param str $where
	 * @param str $order
	 * @param str $limit
	 * @return array
	 */
	function obtener_BD(&$bd,$campos,$tablas,$where,$order,$limit){
		if (is_int($limit)) $limit = "LIMIT ".$limit;
		// TODO: Cambiar el die() por una excepcion lanzada
		if (!is_a($bd,'zen_basedatos')) die("La clase pasada a obtener_BD no es una clase zen_basedatos");
		$r = $bd->seleccion($campos." from ".$tablas." ".$where." ".$order." ".$limit);
		if (!$r) return false;
		$tuplas = array();
		while ($tupla = $bd->obtener_fila($r)) {
			array_push($tuplas,$tupla);
		}
		@mysql_free_result($r);
		return $tuplas;
	}
	/**
	 * Devuelve el entero de $id si corresponde con la BD
	 *
	 * @param int $id
	 * @return int
	 */
	function existe($id)
	{
		$c = split(",",trim($this->campos));
		return intval($this->bd->seleccion_unica($c[0]." from ".$this->tablas." where ".$c[0]."=".intval($id)));
	}
	/**
	 * Inserta datos desde el array pasado con los campos pasados y devuelve el nuevo indentificador pasado
	 *
	 * @param array $datos
	 * @return int
	 */
	function insertar(&$datos){
		$c = split(",",$this->campos);		
		$sql = $this->tablas."(".$this->campos.") values(";
		$n = sizeof($datos);
		for($i=0; $i<sizeof($c);$i++){
			if ($i==0) $sql .= (isset($datos[$i]))?intval($datos[$i]):0; //Autonumerico
			else {
				//if ($i<=$n) $sql .=",";
				$sql .=",'";
				$sql .= isset($datos[$c[$i]])?addslashes($datos[$c[$i]]):'';
				$sql .= "'";
			}
			
		}
		$sql .=");";
		return $this->bd->insertar($sql);
	}
	/**
	 * Actualiza los datos pasados en el array $datos y devuelve el numero de tuplas afectadas
	 *
	 * @param array $datos
	 * @return int
	 */
	function actualizar($datos){
		$c = split(",",$this->campos);
		$sql = $this->tablas." SET ";
		//El id se deja para el final,como condicion del where
		for ($i=1; $i<count($c); $i++){
			if ($i>1 /*&& ($i<sizeof($datos)-1)*/) $sql .= ",";
			$sql .= $c[$i]."='".addslashes($datos[$c[$i]])."'";
		}
		$sql .= " where ".$c[0]."=".intval($datos[$c[0]]);
		return $this->bd->actualizar($sql);
	}
	/**
	 * Borra una tupla con un id especifico y devuelve el numero de campos borrados como resultado
	 *
	 * @param int $id
	 * @return int
	 */
	function borrar($id){
		$c = split(",",$this->campos);
		return $this->bd->borrar($this->tablas." where ".$c[0]."='".addslashes($id)."';");
	}
}
?>