<?php
/**
 * @file zen_ficheros.php
 * @author Juan Belon
 * @access public
 * @copyright LGPL, GPL
 * @package zenphp
 * @version 1.0
 * @uses zenphp FrameWork
 * 
 * @brief Conjunto de funciones para operar/crear/modificar ficheros usando PHP
 */
// +----------------------------------------------------------------------
// | zenphp.es
// +----------------------------------------------------------------------
/**
 * Guardar un fichero en una carpeta concreta. Devuelve false si ha habido un error,lo guarda en $errores.
 * En otro caso devuelve el fichero tal como quedaria almacenado en el hdd del servidor (sin la ruta).
 *
 * @param str $nombre
 * @param str $directorio_destino
 * @param str $errores
 * @return str
 */
function zen_guardarFichero($nombre='fichero',$directorio_destino,&$errores){
	if (!isset($_FILES[$nombre]['name'])) return "";
	$fichero = ereg_replace('(([^0-9a-zA-Z_\.])+)', "",basename($_FILES[$nombre]['name']));
	if(empty($fichero)){
		$errores = ZF_ERROR_NO_FICHERO_VACIO;
		return false;
	}
	if (!is_dir($directorio_destino)) {
		$directorio_destino = ZF_DIR_PPAL . $directorio_destino;
		if (!is_dir($directorio_destino)) {
			$errores = ZF_ERROR_DIR_NO_EXISTE;
			return false;
		}
	}
	$destino = $directorio_destino . $fichero;
	if (!move_uploaded_file($_FILES[$nombre]['tmp_name'],$destino)) {
		$errores = ZF_ERROR_SUBIENDO_F;
		return false;
	}
		
	return $fichero;
}
?>